joylink SDK unit test
===========================

### 1) Download, Install and build CppUTest
Build external libaray mosquitto
```
cd {ROOT_OF_SDK}/external_libs/mosquitto
mkdir build
cd build
cmake ..
make
```

### 2) Download, Install and build CppUTest

Download the latest source code package from cpputest.org and put it into the directory external_libs/CppUTest.  You can also check it out from github using below command.

```
git clone https://github.com/cpputest/cpputest.git {ROOT_OF_SDK}/external_libs/CppUTest --depth=1
```

NOTE:  You cannot ‘apt-get install cpputest’ for use the unit test of joylink SDK.  Please install it as follows:

```
cd external_libs/CppUTest
autoreconf . -i
./configure
make tdd
```

You should see CppUTest’s tests run.  If you get build errors, they are often easy to fix by looking at the error message.  Often it is a matter of disabling some warning. 

### 3) Build and Run the test cases of joylink SDK
From a terminal window, change the directory to {ROOT_OF_SDK}/tests/.
```
	cd {ROOT_OF_SDK}/tests
	make all
```

You should see output announcing each file compiling and finally running the tests like this (don't worry if the numbers don't match):

```
compiling AllTests.cpp
compiling joylink_sdk_start_test.cpp
compiling joylink_sdk_start.c
compiling joylink_sdk_client.c
compiling joylink_auto_rpt.c
compiling joylink_msg_payload.c
compiling joylink_msg_topic.c
compiling client_props.c
compiling joylink_dev_shadow.c
compiling joylink_dev_jobs.c
......
Building archive test-lib/libJoylinkSDKTest.a
a - test-obj/../src/sdk/joylink_sdk_start.o
a - test-obj/../src/sdk/joylink_sdk_client.o
a - test-obj/../src/sdk/joylink_auto_rpt.o
a - test-obj/../src/sdk/joylink_msg_payload.o
a - test-obj/../src/sdk/joylink_msg_topic.o
......
Linking JoylinkSDKTest_tests
Running JoylinkSDKTest_tests
.
OK (xx tests, xx ran, x checks, x ignored, x filtered out, xxxx ms)
```
